Uses CRT, WinAPI, SndBlast, WAVIO, MultiChn; { Compile/Target.../Protected :-) }

Const
  ErrorMsg : Array [1..4] of String[25] =
    ('File not found.', 'Unknown file format.',
     'Not enough memory.', 'File i/o error.');

Var
  C : Char;
  I : Byte;
  P : Array [0..ChanCnt-1] of Pointer;
  S : Array [0..ChanCnt-1] of LongInt;
  Chans, BPSm, Error : Word;
  Freq, BPSc : LongInt;

Begin
  If not CheckEnvironment then Begin
    WriteLn ('Could not find BLASTER variable in the environment.');
    Exit
  End;
  If not ResetSB then Begin
    WriteLn ('Could not reset Sound Blaster card.');
    Exit
  End;
  ClrScr;
  WriteLn ('Go in water (arrows), fire (space), exit - esc');

  LoadWAVas8bit ('8WIND.WAV', P[0], S[0], Chans, Freq, BPSc, BPSm, Error);
  LoadWAVas8bit ('WATSTEP1.WAV', P[1], S[1], Chans, Freq, BPSc, BPSm, Error);
  LoadWAVas8bit ('EXPLODE5.WAV', P[2], S[2], Chans, Freq, BPSc, BPSm, Error);
  AddChannel (P[0], (S[0] div 1024)*1024, 32, True, 0);

  Set_DMA_End_Handler;
  SetStereoIO (Chans=2);
  MixChannels;
  LongPlayBack (@MixBuf, MixBufSize, BPSc);
  Repeat
    If KeyPressed then C := ReadKey
    Else C := #$FF;
    Case C of
      'H','K','M','P' : AddChannel (P[1], S[1], 42, False, 0);
                                                      { Left/Right/Up/Down }
      ' ' : AddChannel (P[2], S[2], 32, False, 0);
                                                      { Space }
    End;
    If not Long_Back_On then Begin
      SlideChannels;
      MixChannels;
      LongPlayBack (@MixBuf, MixBufSize, BPSc);
    End;
  Until C = #27;
  StopDMA;
  SpeakerOff;
  Restore_DMA_End_Handler;
  FreeDOSBuf;
  For I := 0 to 2 do
    GlobalFreePtr (P[I])
End.
